How to contribute to PyFlange
================================================================================

If you want to contribute to the PyFlange project, first of all thank you! 
This document provides guidelines about the most common ways of contributing.



Reporting a bug
--------------------------------------------------------------------------------
If you find a bug in PyFlange, you can help by reporting it, so that someone
else can fix it. Unless, of course, you know how and want to fix it yourself;
in that case see the section [Submitting code improvements](#submitting-code-improvements)
below.

A bug can be submitted by [opening a GitHub issue](https://docs.github.com/en/issues), 
but before doing that, please look at the open issues to see if the same
bug has already been reported. If so, you can add your contribution to the
existing issue.



Requesting improvements
--------------------------------------------------------------------------------

If there is a functionality that you would like to see added to PyFlange,
please [open a GitHub issue](https://docs.github.com/en/issues), describing
the new functionality and explaining why, in your opinion, it is needed. A
discussion will follow and eventually someone will be assigned to the 
implementation of the new functionality.

If you want to implement the new functionality yourself, you can do so by
[submitting a pull request](#submitting-code-improvements), but before
doing that, please consult the other contributors by opening an issue.



Submitting code improvements
--------------------------------------------------------------------------------

Codes modifications and improvements should be submitted via a 
[pull request](https://docs.github.com/en/pull-requests). Before submitting the
pull request, the necessity of the code modification should be discussed in
a issue (see [Requesting improvements](#requesting-improvements)).

> Since the typical PyFlange user  is expected not to be a professional
> programmer and probably not familiar with Git, we have created a
> [Git tutorial for non-programmers](https://kcibv.github.io/git-tutorial/) 
> to make the process of creating a pull request less intimidating.

See also [this article](https://docs.github.com/en/get-started/exploring-projects-on-github/contributing-to-a-project) about contributing to a project and submitting pull requests.



Asking a question
--------------------------------------------------------------------------------
Asking a question is also a form of contribution, equivalent to submitting a
bug about the project documentation, which is not complete or not clear. Of
course, before submitting a question, make sure you have read the documentation
and all the questions submitted by other contributors.

A question can be asked by [opening a GitHub issue](https://docs.github.com/en/issues).
